commit ae3227710c71ca693ee43c825f5d0d0fbd3c3773
Author: Richard Biener <rguenther@suse.de>
Date:   Thu Sep 30 15:05:53 2021

    middle-end/102518 - avoid invalid GIMPLE during inlining
    
    When inlining we have to avoid mapping a non-lvalue parameter
    value into a context that prevents the parameter to be a register.
    Formerly the register were TREE_ADDRESSABLE but now it can be
    just DECL_NOT_GIMPLE_REG_P.
    
    2021-09-30  Richard Biener  <rguenther@suse.de>
    
            PR middle-end/102518
            * tree-inline.c (setup_one_parameter): Avoid substituting
            an invariant into contexts where a GIMPLE register is not valid.
    
            * gcc.dg/torture/pr102518.c: New testcase.

diff --git a/gcc/testsuite/gcc.dg/torture/pr102518.c b/gcc/testsuite/gcc.dg/torture/pr102518.c
new file mode 100644
index 00000000000..bd181ec9d99
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/torture/pr102518.c
@@ -0,0 +1,12 @@
+/* { dg-do compile } */
+
+struct A {
+  int *x;
+};
+int i;
+int f(int *const c) {
+  struct A * b = (struct A *)(&c);
+  return b->x != 0;
+}
+void g() { f(&i); }
+
diff --git a/gcc/tree-inline.c b/gcc/tree-inline.c
index 6e0c16bc355..48588c41b35 100644
--- a/gcc/tree-inline.c
+++ b/gcc/tree-inline.c
@@ -3476,7 +3476,11 @@ setup_one_parameter (copy_body_data *id, tree p, tree value, tree fn,
 	 invalid sharing when operand is not really constant.
 	 It is not big deal to prohibit constant propagation here as
 	 we will constant propagate in DOM1 pass anyway.  */
-      if (is_gimple_min_invariant (value)
+      if ((is_gimple_min_invariant (value)
+	   /* When the parameter is used in a context that forces it to
+	      not be a GIMPLE register avoid substituting something that
+	      is not a decl there.  */
+	   && ! DECL_NOT_GIMPLE_REG_P (p))
 	  && useless_type_conversion_p (TREE_TYPE (p),
 						 TREE_TYPE (value))
 	  /* We have to be very careful about ADDR_EXPR.  Make sure

